# ssn.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das tcl liest die shortnews.stern.de news aus und gibt sie wieder, gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
#
# v1.0 - umbennenung von shortnews.tcl nach ssn.tcl
#      - komplett umgebaut by public request
#      - link wird gleich mitgepostet
#      - yeah  endlich  keine  windrop  user  mehr die mich fragen was lynx ist
#        so gerne ich support leiste - jeden tag ne  mail mit der  selben frage
#        stresst ziemlich ;)
#
# ssntrigger - der trigger auf den der bot reagiert (public und message)
# ssnlimit - maximum der news die auf befehl geposted werden
# ssnnewspost  - 1 fr newsposting, 0 fr keines
# ssnchans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# ssnnewspostlimit - maximum der news die geposted werden
# isssnhub  - legt fest ob der bot newshub ist oder nicht
# ssnleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set ssntrigger ".ssn"
set ssnchans ""
set ssnlimit "5"
set ssnnewspostlimit "5"
set ssnnewspost "1"
set isssnhub "0"
set ssnleafs ""

####### ende der config #############

bind msg - $ssntrigger msg_ssn
bind pub - $ssntrigger pub_ssn
bind time - "?0 * * * *" ssncheck

proc sendssnnews { arg } {
global ssnleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $ssnleafs] [string tolower $bot]] != -1)} {
putbot $bot "ssn: $arg"
}}}

proc html { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
return $text
}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc ssnnews { target limit } {
if {[catch {set sock [socket shortnews.stern.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /start.cfm?rubrik1=Alles&rubrik2=Alles&rubrik3=Alles&sort=3&zeitraum=1&sparte=4 HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: shortnews.stern.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "face=\"arial,helvetica\" size=\"2\" color=\"\">" $bl] != -1 } {
set newsline [string range $bl [shrink + 9 "color=\"\">" 0 $bl] [shrink - 1 </a> 0 $bl]]
set link http://shortnews.stern.de/[string range $bl [shrink + 8 "a href=\"" 0 $bl] [shrink - 1 "\"><font" 0 $bl]]
putserv "privmsg $target :[incr counter] [html $newsline] <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc ssncheck {nick uhost hand chan arg} {
global ssnchans ssnnewspost isssnhub ssnnewspostlimit
set counter 0
if {$ssnnewspost == 1 } {
putlog "ssn: suche nach neuer newsline"
set ssnlastnews "none"
if {[file exists ssn.hdl]} {
set temp [open "ssn.hdl" r]
set ssnlastnews "[gets $temp]"
close $temp
}
set temp [open "ssn.hdl" w+]
if {[catch {set sock [socket shortnews.stern.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /start.cfm?rubrik1=Alles&rubrik2=Alles&rubrik3=Alles&sort=3&zeitraum=1&sparte=4 HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: shortnews.stern.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "face=\"arial,helvetica\" size=\"2\" color=\"\">" $bl] != -1 } {
set newsline [string range $bl [shrink + 9 "color=\"\">" 0 $bl] [shrink - 1 </a> 0 $bl]]
set link http://shortnews.stern.de/[string range $bl [shrink + 8 "a href=\"" 0 $bl] [shrink - 1 "\"><font" 0 $bl]]
puts $temp "[html $newsline] <$link>"
}}}
close $sock ; close $temp
if {$ssnlastnews == "none" } { putlog "ssn: headlinefile created" ; return 0 }
set temp [open "ssn.hdl" r]
while { [eof $temp] != 1 } {
set ssnneunews [gets $temp]
if {($ssnlastnews == $ssnneunews) || ($counter == $ssnnewspostlimit)} { close $temp;return 0 }
if { $isssnhub == "1" } { sendssnnews $ssnneunews }
foreach chan [channels] {
if {$ssnchans == "" } { putserv "privmsg $chan :(neue ssn newsline) $ssnneunews" }
if {$ssnchans != "" } {
if {([lsearch -exact [string tolower $ssnchans] [string tolower $chan]] != -1) || ($ssnchans == "")} {putserv "privmsg $chan :(neue ssn newsline) $ssnneunews"}
}
incr counter
}}}}


proc msg_ssn { nick uhost hand arg } { global ssnlimit ; ssnnews $nick $ssnlimit }
proc pub_ssn { nick uhost hand chan arg } { global ssnchans ssnlimit ; if {([lsearch -exact [string tolower $ssnchans] [string tolower $chan]] != -1) || ($ssnchans == "")} { ssnnews $nick $ssnlimit }}


putlog "*** ssn.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
